// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

public interface QualityOrBuilder extends
    // @@protoc_insertion_point(interface_extends:commonmodule.Quality)
    com.google.protobuf.MessageOrBuilder {

  /**
   * <pre>
   * Describes some reasons in case 'validity' is not 'good'.
   * </pre>
   *
   * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the detailQual field is set.
   */
  boolean hasDetailQual();
  /**
   * <pre>
   * Describes some reasons in case 'validity' is not 'good'.
   * </pre>
   *
   * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The detailQual.
   */
  openfmb.commonmodule.DetailQual getDetailQual();
  /**
   * <pre>
   * Describes some reasons in case 'validity' is not 'good'.
   * </pre>
   *
   * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  openfmb.commonmodule.DetailQualOrBuilder getDetailQualOrBuilder();

  /**
   * <pre>
   * (default=false) If true, further update of the value has been blocked by an operator. The value
   * shall be the information that was acquired before blocking. If this flag is set, then the
   * 'detailQual.oldData' shall also be set. The operator shall use the data attribute 'CDC.blkEna' to
   * block the update of the value. NOTE Both an operator as well as an automatic function may freeze
   * communication updating as well as input updating. In both cases, 'detailQual.oldData' will be set.
   * If the blocking is done by an operator, then this flag is set additionally, and an operator activity
   * is required to clear the condition.
   * </pre>
   *
   * <code>bool operatorBlocked = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The operatorBlocked.
   */
  boolean getOperatorBlocked();

  /**
   * <pre>
   * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
   * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
   * There are various means to clear a substitution. As an example, a substitution that was done
   * following an invalid condition may be cleared automatically if the invalid condition is cleared.
   * However, this is a local issue and therefore not within the scope of this standard.
   * </pre>
   *
   * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The enum numeric value on the wire for source.
   */
  int getSourceValue();
  /**
   * <pre>
   * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
   * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
   * There are various means to clear a substitution. As an example, a substitution that was done
   * following an invalid condition may be cleared automatically if the invalid condition is cleared.
   * However, this is a local issue and therefore not within the scope of this standard.
   * </pre>
   *
   * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The source.
   */
  openfmb.commonmodule.SourceKind getSource();

  /**
   * <pre>
   * (default=false) If true, the value is a test value. The processing of the test quality in the
   * client shall be as described in IEC 61850-7-4. This bit shall be completely independent from the
   * other bits within the quality descriptor.
   * </pre>
   *
   * <code>bool test = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The test.
   */
  boolean getTest();

  /**
   * <pre>
   * Validity of the value, as condensed information for the client. In case this value is not
   * 'good', some reasons may be found in the 'detailQual'.
   * </pre>
   *
   * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The enum numeric value on the wire for validity.
   */
  int getValidityValue();
  /**
   * <pre>
   * Validity of the value, as condensed information for the client. In case this value is not
   * 'good', some reasons may be found in the 'detailQual'.
   * </pre>
   *
   * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The validity.
   */
  openfmb.commonmodule.ValidityKind getValidity();
}
